﻿using Adaptation.Shared;
namespace Adaptation.Si
{

    public class PreRunInfo
    {

        public string MID { get; private set; }
        public string RunNumber { get; private set; }
        public string Recipe { get; private set; }
        public string PartNumber { get; internal set; }
        public string Date { get; private set; }
        public string PocketNumber { get; private set; }
        public string WaferLot { get; private set; }
        public string SatelliteGroup { get; private set; }
        public string StartStamp { get; private set; }
        public Logistics Logistics { get; private set; }

        public PreRunInfo(Logistics logistics, object partNumber)
        {
            MID = logistics.MID;
            RunNumber = string.Empty;
            Recipe = string.Empty;
            PartNumber = partNumber.ToString();
            Date = logistics.DateTimeFromSequence.ToString();
            PocketNumber = "00";
            WaferLot = string.Empty;
            SatelliteGroup = string.Empty;
            StartStamp = logistics.DateTimeFromSequence.ToString();
            Logistics = logistics;
        }

        public PreRunInfo(Logistics logistics, object mID, object runNumber, object recipe, object partNumber, object date, object pocketNumber, object waferLot, object satelliteGroup, object startStamp)
        {
            MID = mID.ToString();
            RunNumber = runNumber.ToString();
            Recipe = recipe.ToString();
            PartNumber = partNumber.ToString();
            Date = date.ToString();
            PocketNumber = pocketNumber.ToString();
            WaferLot = waferLot.ToString();
            SatelliteGroup = satelliteGroup.ToString();
            StartStamp = startStamp.ToString();
            Logistics = logistics;
        }

        public override string ToString()
        {
            return string.Concat(MID, " - ", RunNumber, " - ", Recipe, " - ", PartNumber, " - ", Date, " - ", PocketNumber, " - ", WaferLot, " - ", SatelliteGroup, " - ", StartStamp);
        }

    }

}